Bug 1408308 - cpu-partitioning: enable timer migration
Summary: cpu-partitioning: enable timer migration
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: tuned
Version: 7.4
Hardware: Unspecified
OS: Unspecified
high
unspecified
Target Milestone: rc
: ---
Assignee: Jaroslav Škarvada
QA Contact: Tereza Cerna
Lenka Kimlickova
URL:
Whiteboard:
Depends On: 1392593
Blocks: 1394932 1439154
TreeView+ depends on / blocked
 
Reported: 2016-12-22 20:46 UTC by Luiz Capitulino
Modified: 2020-06-11 13:10 UTC (History)
5 users (show)

Fixed In Version: tuned-2.8.0-1.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1439154 (view as bug list)
Environment:
Last Closed: 2017-08-01 12:32:51 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2017:2102 normal SHIPPED_LIVE tuned bug fix and enhancement update 2017-08-01 16:07:33 UTC

Description Luiz Capitulino 2016-12-22 20:46:35 UTC
Description of problem:

The cpu-partitioning profile disables timer migration in /usr/lib/tuned/cpu-partitioning/tuned.conf:

kernel.timer_migration = 0

The reason for this is probably because in current RHEL7, timers are migrated from idle CPUs to busy CPUs. In other words, CPUs running PMD threads would "attract" timers from idle CPUs.

However, the proposed fix for bug 1392593 (see bug 1392593 comment 10) changes the timer migration algorithm to the following:

1. Always migrate unpinned timers away from nohz_full CPUs
2. When migrating a timer, pick a housekeeping CPU as a target (ie. don't pick a nohz_full CPU)

With this behavior, we actually want to enable timer migration for two reasons:

1. There are long living timers that are created during bootup on a CPU, as explained in bug 1392593 itself. We want those timers to be migrated away from nohz_full

2. If, for whatever reason, the kernel code creates a timer on a CPU running a PMD thread (which will for sure be a nohz_full CPU) we want this timer to fire on a housekeeping core

For this reason, timer migration should be enabled in the cpu-partitioning profile.


Version-Release number of selected component (if applicable): tuned-profiles-cpu-partitioning-2.7.1-5.el7fdp.noarch

Comment 8 Tereza Cerna 2017-04-26 10:24:19 UTC
Verified in:
    tuned-2.8.0-2.el7.noarch
PASS


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: [   LOG    ] :: Check profile settings of section [sysctl] [Sanity,BZ#1408308]
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

:: [   PASS   ] :: Command 'sysctl kernel.hung_task_timeout_secs | grep 600' (Expected 0, got 0)
:: [   PASS   ] :: Command 'sysctl kernel.nmi_watchdog | grep 0' (Expected 0, got 0)
:: [   PASS   ] :: Command 'sysctl vm.stat_interval | grep 10' (Expected 0, got 0)
:: [   PASS   ] :: Command 'sysctl kernel.timer_migration | grep 1' (Expected 0, got 0)
:: [   LOG    ] :: Duration: 0s
:: [   LOG    ] :: Assertions: 4 good, 0 bad
:: [   PASS   ] :: RESULT: Check profile settings of section [sysctl] [Sanity,BZ#1408308]

Comment 12 errata-xmlrpc 2017-08-01 12:32:51 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2017:2102


Note You need to log in before you can comment on or make changes to this bug.